/* Copyright (c) 2015-2018 Skyward Experimental Rocketry
 * Authors: Luca Erbetta
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#pragma once

#include <drivers/adc/ADC.h>
#include <miosix.h>
/*
 * GLOBAL SETTINGS
 */
// Enable or disable sensors
#define USE_GPS
#define USE_MPU9255
#define USE_BME280

#define SD_LOGGING

// These must not be enabled if not in DEBUG mode
#ifdef DEBUG
//  #define IGNORE_LOGGER_NOT_WORKING
//  #define IGNORE_SENSORS_NOT_WORKING
#endif
//#define ENABLE_CALIBRATION

/*
 * Sensor settings
 */
static const int IMU_SAMPLE_RATE   = 150;
static const int GPS_SAMPLE_RATE   = 5;
static const int PRESS_SAMPLE_RATE = 20;

static constexpr int ADC_SAMPLE_RATE = 20;

using CURRENT_CSENSE = miosix::Gpio<GPIOC_BASE, 4>;

static constexpr unsigned int CURRENT_SENSE_ADC_NUM = 1;
static constexpr unsigned int CURRENT_SENSE_ADC_CH = 14;

using ADC_t = SensorADC<CURRENT_SENSE_ADC_NUM>;


#if !defined SD_LOGGING && !defined DEBUG
#error "SD LOGGER IS NOT ENABLED"  //If we are compiling for release, SD logger should be enabled
#endif