/* Copyright (c) 2015-2018 Skyward Experimental Rocketry
 * Authors: Luca Erbetta
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#pragma once

#include <stdint.h>
#include <events/Event.h>
#include <events/EventBroker.h>

enum SharedEvents : uint8_t
{
    EV_BUTTON_PRESS = EV_FIRST_SIGNAL,
    EV_BUTTON_LONG_PRESS,
    EV_BUTTON_LONG_LONG_PRESS,

    EV_LOGGER_ERROR,
    EV_SENSOR_INIT_ERROR,
    EV_START_CALIBRATION,

    EV_START_SAMPLING,
    EV_START_SENSOR_LOGGING,
    EV_CLOSE_LOG,

    EV_FIRST_UNSHARED_SIGNAL // Non shared events start counting from here
};

enum SharedTopics : uint8_t
{
    TOPIC_FSM,
    TOPIC_COORDINATION,
    TOPIC_STATUS,
    TOPIC_USER_INPUT
};

